#!/usr/bin/python

import os, re, config

class files:
	def __init__(self, dir):
		self.__findMP3s__		= re.compile('\\.(?:mp|MP)3$')
		self.renameMP3s			= re.compile('^(?:\\[\\d*\\] |)(.*)\\.(?:mp|MP)3$')
		self.removeChars		= re.compile('\\,|\\.|\\?|\\(|\\)|\\[|\\]|\\||\\/\\\\')
		self.__topdir__			= dir
		self.__filelist__		= []
		self.__indexedlist__	= []
		self.__genfilelist__(dir)
		self.__searchString__	= ""
		self.__genSearchList__()
		self.__pastlist__		= []
	
	def __genfilelist__(self, dir):
		try: cdir = os.listdir(dir)
		except: cdir = []
		for i in cdir:
			if i[0] == ".":			# we don't want to handle hidden directories
				pass
			elif self.__findMP3s__.search(i) != None:	# mp3s are not recursable ;)
				index = len(self.__filelist__)
				# add the file to the file list
				self.__filelist__.append(os.path.join(dir,i))
				# add files to the indexed search list
				parts	= [index]
				i2		= self.renameMP3s.sub('\\1', i)
				parts	+= self.removeChars.sub('', i2).split(' ')
				# ok, this is where it gets whacked out, we want to add the albulm
				# name into the things we can search for. This means we need to add
				# it into parts, however, we also need to detect that what we're inside
				# is an album (though this is not strictly necessary, it will reduce the
				# things we have to iterate through during a search)
				basename	= os.path.basename(dir)
				if self.__topdir__ != dir and os.path.join(self.__topdir__, basename) != dir:
					# we could be in one of two places
					if basename.lower()[:4] == 'disc':
						basename	= os.path.basename(os.path.dirname(dir))
					# we're probably in an albulm name
					# lets add the albulm name into the indexed list
					parts += basename.split(' ')
				## we removed the unwanted list, it sucks
				# however, lets remove random -'s they suck too
				try: parts.remove('-')
				except: pass
				self.__indexedlist__.append(parts)
				
			else:					# recurse through the directory tree
				self.__genfilelist__(os.path.join(dir,i))
	
	def get(self):
		return self.__filelist__
	
	def getRandom(self):
		import random
		while True:
			# generate a random number
			rnd = random.random()
			song = self.__filelist__[int(len(self.__filelist__) * rnd)]
			if song not in self.__pastlist__: break
		return song
	
	def addPast(self, song):
		# this makes a list of songs that we don't want to play
		# any time soon.
		self.__pastlist__.append(song)
		# trim this list down to 'x' songs
		if len(self.__filelist__) < config.remember_songs: x = len(self.__filelist__) - 1
		else: x = config.remember_songs
		self.__pastlist__ = self.__pastlist__[:x]
	
	def canGetLast(self):
		return len(self.__pastlist__) - 1 > 0
	
	def getLast(self):
		return self.__pastlist__.pop()
	
	def resetSearch(self):
		self.__searchString__ = ""
		self.__genSearchList__()
	
	def __genSearchList__(self):
		self.__searchList__ = self.__indexedlist__
		self.__tainted__	= False
	
	def addSearchCharacter(self, character):
		self.__searchString__ += character.upper()
	
	def delSearchCharacter(self, no = 0):
		st = self.__searchString__
		self.__searchString__	= st[:-no]
		# we have to reset the search list
		if self.__tainted__: self.__genSearchList__()
	
	def doSearch(self):
		self.__tainted__	= True
		# split up the search words
		st = self.__searchString__.strip().split(' ')
		# go through the old list and remove all the non matches
		working_possibles	= self.__searchList__
		for n in st:
			possibles = []
			for i in working_possibles:
				for j in i[1:]:		# ahh, here it is; this ensures we leave the index number out of our search
					# if the word we're looking for is one of the words
					if n == j[:len(n)].upper():
						possibles.append(i)
						break
			working_possibles = possibles
		self.__searchList__ = working_possibles
	
	def getSearch(self):
		output = []
		for i in self.__searchList__:
			n = i[0]
			output.append(self.__filelist__[n])
		return output
